=== debian/changelog ===
coq (8.5-2) unstable; urgency=medium

  * patch: disable test 4429 (timeout too strict for slow architectures) 

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 28 Jan 2016 11:47:07 +0100

coq (8.5-1) unstable; urgency=medium

  * New upstream release 
  * patch: disable test 4366 (timeout too strict for slow architectures)

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 26 Jan 2016 16:59:05 +0100

coq (8.5~beta3+dfsg-2) experimental; urgency=medium

  * Option -no-native-compiler now called -native-compiler no 

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 14 Nov 2015 14:59:04 +0100

coq (8.5~beta3+dfsg-1) experimental; urgency=medium

  * New upstream release

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 13 Nov 2015 11:27:35 +0100

coq (8.5~beta2+dfsg-2) experimental; urgency=medium

  * Enable native compiler only on amd64 and i386
  * Enable 'make test-suite' target

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 20 Jul 2015 09:51:21 +0200

coq (8.5~beta2+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Add Enrico Tassi to uploaders
  * Disable patch for lockf on Hurd (not needed anymore)
  * coq-theories is now arch any, since it contains .coq-native/ directories
    (i.e. cmxs files for native compute)
  * coq depends on coq-theories binary:Version
  * lintian-overrides for coq-native/*cmx* and plugins/*cmxs files
    (hardening-no-relro)
  * Build depend on liblablgtksourceview2-ocaml-dev 

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 15 Jul 2015 11:36:30 +0200
