## coq 8.6

=== debian/changelog ===
coq (8.6-4) unstable; urgency=medium

  * coq_makefile needs ocamlfind in order to work 

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 29 Dec 2016 23:45:47 +0100

coq (8.6-3) unstable; urgency=medium

  * 5127.v fails on mips, disabling 

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 29 Dec 2016 08:58:35 +0100

coq (8.6-2) unstable; urgency=medium

  * Disable some tests with hardcoded timeout to fix FTBFS on
    slow machines

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 28 Dec 2016 18:19:29 +0100

coq (8.6-1) unstable; urgency=medium

  * New upstream release 

 -- Enrico Tassi <gareuselesinge@debian.org>  Tue, 27 Dec 2016 16:53:39 +0100
