=== debian/control ===
--- 
+++ 
@@ -31,7 +31,8 @@
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}, 
- ocaml-best-compilers
+ ocaml-best-compilers,
+ ocaml-findlib
 Provides: coq-${F:CoqABI}
 Recommends: coqide | proofgeneral
 Suggests:
