=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 PACKAGES := $(shell dh_listpackages)
 
-COQ_VERSION := 8.5
+COQ_VERSION := 8.6
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 ARCH := $(shell dpkg-architecture -q DEB_TARGET_ARCH)
@@ -105,7 +105,7 @@
 
 .PHONY: override_dh_ocaml
 override_dh_ocaml:
-	dh_ocaml --nodefined-map coqide:Xmlprotocol,Ide_slave
+	dh_ocaml --nodefined-map coqide:Xmlprotocol,Ide_slave,Xml_printer,Richprinter,Document,Xml_parser,Xml_lexer,Serialize
 	for f in debian/*substvars; do echo $$f; cat $$f; done
 
 .PHONY: override_dh_gencontrol
